-- DEMO PAGE FOR immediateUI BUTTONS
function setup()
    --no setup needed
end

function draw()
    background(209, 208, 224)
    
    rectMode(CENTER)
    stroke(90, 146, 210)
    fill(255)
    strokeWidth(3)
    font("Helvetica")
    fontSize(20)
    
    button("This is immediateUI!", WIDTH*0.3, HEIGHT - 80, function()
        print("button 1 pressed")
    end)
    
    button("use it like this:", WIDTH*0.7, HEIGHT - 140, function()
        print("button 2 pressed")
    end)
    
    button("'button(text, x, y, callback)'", WIDTH*0.4, HEIGHT - 200, function()
        print("button 3 pressed")
    end)
    
    button("...call it in draw()", WIDTH*0.6, HEIGHT - 260, function()
        print("button 4 pressed")
    end)
    
    button("...just like rect & ellipse", WIDTH*0.35, HEIGHT - 320, function()
        print("button 5 pressed")
    end)
    
    button("...no setup needed!", WIDTH*0.65, HEIGHT - 380, function()
        print("button 6 pressed")
    end)
    
    textWrapWidth(265) -- Set a global wrap width
    button("it automatically sets the button size to fit the text, "..
    "even blocks of text like this.",  195, 380, function()
        print("multiline button pressed")
    end)
    textWrapWidth(0)  -- Reset for subsequent buttons
    
    -- Button manually sized larger than the text
    pushStyle()
    fill(255, 200, 150)
    stroke(255, 0, 150)
    strokeWidth(20)
    font("AmericanTypewriter-Semibold")
    fontSize(12)
    textWrapWidth(230)
    button("It draws using the current stroke, fill, font, and fontSize " ..
    "(text uses the stroke color in this case). " ..
    "And you can manually set button size too.", 190, 150, WIDTH - 20, 180, function()
        print("custom-styled button pressed")
    end)
    popStyle()
    
    -- draggable button
    fill(150, 255, 150)
    if not draggableX then
        draggableX = 233
        draggableY = 285
    end
    button("Easy to make draggable!", draggableX, draggableY, function()
        print("draggable button pressed. did you try dragging it?")
    end)
end

function touched(touch)
    immediateUI(touch)
    -- Update draggable button position when dragging
    if touch.state == MOVING then
        if pointInRectByCurrentMode(touch.x, touch.y, draggableX or WIDTH * 0.5, draggableY or HEIGHT * 0.3, 300, 60) then
            draggableX = touch.x
            draggableY = touch.y
        end
    end
end

